#!/usr/bin/perl

#    prices.pl - Price utility
#    Copyright (C) 2003 Michael Jung
#    e-mail: miju@phantasia.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$| = 1;

$FILE_LOCATION = "../cgi-tmpl/prices/";

#########
### CONSTANTS
#########

@scal = ([.8, .9], [.9, 1.1], [1.1, 1.3], [1.3, 1.5]);

$pid = getppid;

open DAT, "<$FILE_LOCATION/price.dat";
while (<DAT>) {
    ($a,$b1,$b2,$b3,$b4,$c) =
        /(\w+)\s+([0-9.]+L)?([0-9.]+d)?([0-9.]+f)?(\+?)\s+(.*)/;
    $p{$a}->{$c} = ((($b1*240) + $b2)*4 + $b3).$b4;
}
close DAT;

@owner = sort keys %p;

#########
### INPUT
#########

$q = new CGI;

foreach $o (@owner) {
    my @t = $q->param($o);
    foreach $t (@t) {
        push @who, [$o, ($t eq "l"?0:($t eq "a"?1:($t eq "h"?2:3)))];
    }
}

$action = $q->param("action");

#########
### CALCULATIONS & OUTPUT
#########

# PREPARE (STD)OUT

%action = ("HTML" => [".html","text/html"],
	   "PS" => [".ps","application/postscript"],
	   "FIG" => [".fig","application/fig"],
	   "PDF" => [".pdf","application/pdf"]);

print $q->header(-type => $action{$action}[1],
		 -attachment => "prices".$action{$action}[0]);

if ($action eq "FIG") {
    print "#FIG 3.2\nPortrait\nCenter\nMetric\n".
        "A4\n100.00\nSingle\n-2\n1200 2\n";
    $entryT = "2 4 0 1 0 0 99 0 -1 0.000 0 0 7 0 0 5\n".
        "\t %d %d %d %d %d %d %d %d %d %d\n";
    $itemT = "4 0 0 99 0 24 10 0.0000 4 100 200 %d %d %s\\001\n";
    $priceT = "4 1 0 99 0 24 10 0.0000 4 100 200 %d %d %s\\001\n";
    $headerT = "2 4 0 1 0 0 99 0 5 0.000 0 0 7 0 0 5\n".
        "\t %d %d %d %d %d %d %d %d %d %d\n";
    $titleT = "4 0 0 99 0 26 10 0.0000 4 100 200 %d %d %s\\001\n";
}
elsif ($action eq "HTML") {
    print "<html>\n<head>\n<title>Pricelist Output - Html</title>\n".
        "</head>\n<body>\n<table cellpadding=4 border=0 cellspacing=4 ".
        "width=100%>\n<tr>";
    $itemT = "<td bgcolor=#ffffff width=66%%>%s</td>\n";
    $priceT = "<td bgcolor=#ffffff width=7%%>%s</d>\n";
    $titleT = "<td bgcolor=#aaaaaa colspan=3><b>%s</b></d>\n";

}
elsif ($action eq "PS" || $action eq "PDF") {
    open LAT, ">/tmp/$pid.tex";
    print LAT "\\documentclass{article}\n\\usepackage{graphics}\n".
        "\\pagestyle{empty}\n\\begin{document}\n\\begin{center}\n".
        "\\vspace*{\\fill}\n\\makebox[1in]{\n".
        "\\raisebox{-.5\\paperheight}[0in][0in]{\n".
        "\\resizebox{!}{\\paperheight}{\\includegraphics{/tmp/$pid.0.eps}}\n";
    $head = "#FIG 3.2\nPortrait\nCenter\nMetric\n".
        "A4\n100.00\nSingle\n-2\n1200 2\n".
        "2 2 0 1 0 7 99 0 -1 0.000 0 0 -1 0 0 5\n".
        "\t 8749 12749 8750 12749 8750 12750 8749 12750 8749 12749\n";
    $entryT = "2 4 0 1 0 0 99 0 -1 0.000 0 0 7 0 0 5\n".
        "\t %d %d %d %d %d %d %d %d %d %d\n";
    $itemT = "4 0 0 99 0 24 10 0.0000 4 100 200 %d %d %s\\001\n";
    $priceT = "4 1 0 99 0 24 10 0.0000 4 100 200 %d %d %s\\001\n";
    $headerT = "2 4 0 1 0 0 99 0 5 0.000 0 0 7 0 0 5\n".
        "\t %d %d %d %d %d %d %d %d %d %d\n";
    $titleT = "4 0 0 99 0 26 10 0.0000 4 100 200 %d %d %s\\001\n";
    open EPS, ">/tmp/$pid.0.fig";
    print EPS $head;
}

$p = $c = 0;
$l = -1;

foreach $i (@who) {
    &inc($action);

    my $pl = ($i->[1]==0?"Low":($i->[1]==1?"Average":($i->[1]==2?"High":"High+")));
    if ($action eq "FIG") {
        printf($headerT, $x1, $y1, $x1 + 4000, $y1, $x1 + 4000, $y2,
               $x1, $y2, $x1, $y1);
        printf($titleT, $x1 + 100,  $y2 - 80, "$i->[0]($pl)");
    }
    elsif ($action eq "HTML") {
        printf($titleT, "$i->[0]($pl)");
    }
    elsif ($action eq "PS" || $action eq "PDF") {
        printf EPS $headerT, $x1, $y1, $x1 + 4000, $y1, $x1 + 4000, $y2,
               $x1, $y2, $x1, $y1;
        printf EPS $titleT, $x1 + 100,  $y2 - 80, "$i->[0]($pl)";
    }

    &inc($action);

    foreach $j (sort keys %{$p{$i->[0]}}) {
        if ($action eq "FIG") {
            printf($entryT, $x1, $y1, $x1 + 2600, $y1, $x1 + 2600, $y2,
                   $x1, $y2, $x1, $y1);
            printf($itemT, $x1 + 100, $y2 - 80, $j);
        }
        elsif ($action eq "HTML") {
            printf $itemT, $j;
        }
        if ($action eq "PS" || $action eq "PDF") {
            printf EPS $entryT, $x1, $y1, $x1 + 2600, $y1, $x1 + 2600, $y2,
                   $x1, $y2, $x1, $y1;
            printf EPS $itemT, $x1 + 100, $y2 - 80, $j;
        }

        my $m = $scal[$i->[1]][0] * $p{$i->[0]}->{$j};
        $m = 4*int($m/4) if (4*int($m/4)/$m > .99);
        $m = 960*int($m/960) if (960*int($m/960)/$m > .99);

        my $mp = int($m/9600);
        my $md = int($m/4-2400*$mp);
        my $mf = $m%4;

        $m = ($mp>0?(10*$mp)."":"").($md>0?$md."d":"").($mf>0?$mf."f":"");

        $m .= "+" if ($p{$i->[0]}->{$j} =~/\+/);

        if ($action eq "FIG") {
            printf($entryT, $x1 + 2600, $y1, $x1 + 3300, $y1, $x1 + 3300, $y2,
                   $x1 + 2600, $y2, $x1 + 2600, $y1);
            printf($priceT, $x1 + 2950, $y2 - 80, $m);
        }
        elsif ($action eq "HTML") {
            printf($priceT, $m);
        }
        elsif ($action eq "PS" || $action eq "PDF") {
            printf EPS $entryT, $x1 + 2600, $y1, $x1 + 3300, $y1,
                $x1 + 3300, $y2, $x1 + 2600, $y2, $x1 + 2600, $y1;
            printf EPS $priceT, $x1 + 2950, $y2 - 80, $m;
        }

        $m = $scal[$i->[1]][1] * $p{$i->[0]}->{$j};
        $m = 4*int($m/4) if (4*int($m/4)/$m > .99);
        $m = 960*int($m/960) if (960*int($m/960)/$m > .99);

        my $mp = int($m/9600);
        my $md = int($m/4-2400*$mp);
        my $mf = $m%4;

        $m = ($mp>0?(10*$mp)."":"").($md>0?$md."d":"").($mf>0?$mf."f":"");

        $m .= "+" if ($p{$i->[0]}->{$j} =~/\+/);

        if ($action eq "FIG") {
            printf($entryT, $x1 + 3300, $y1, $x1 + 4000, $y1, $x1 + 4000, $y2,
                   $x1 + 3300, $y2, $x1 + 3300, $y1);
            printf($priceT, $x1 + 3650, $y2 - 80, $m);
        }
        elsif ($action eq "HTML") {
            printf($priceT, $m);
        }
        elsif ($action eq "PS" || $action eq "PDF") {
            printf EPS $entryT, $x1 + 3300, $y1, $x1 + 4000, $y1,
                $x1 + 4000, $y2, $x1 + 3300, $y2, $x1 + 3300, $y1;
            printf EPS $priceT, $x1 + 3650, $y2 - 80, $m;
        }

        &inc($action);
    }
}

if ($action eq "HTML") {
    print "</tr>\n</table>\n</body>\n</html>\n";
}
elsif ($action eq "PS") {
    print LAT "}\n}\n\\vspace*{\\fill}\\end{center}\n\\end{document}\n";
    close LAT;
    close EPS;
    system("/usr/X11R6/bin/fig2dev -L eps /tmp/$pid.$_.fig ".
           "/tmp/$pid.$_.eps")
        foreach (0..$p);
    system("cd /tmp; /usr/bin/latex $pid.tex > /dev/null; ".
           "/usr/bin/dvips $pid 2>/dev/null; cat $pid.ps");
    system("rm -f /tmp/$pid.*");
}
elsif ($action eq "PDF") {
    print LAT "}\n}\n\\vspace*{\\fill}\\end{center}\n\\end{document}\n";
    close LAT;
    close EPS;
    system("/usr/X11R6/bin/fig2dev -L eps /tmp/$pid.$_.fig ".
           "/tmp/$pid.$_.eps")
        foreach (0..$p);
    system("cd /tmp; /usr/bin/latex $pid.tex >/dev/null; ".
           "/usr/bin/dvipdf $pid.dvi $pid.pdf 2>/dev/null; cat $pid.pdf");
    system("rm -f /tmp/$pid.*");
}

sub inc {
    if ($_[0] eq "FIG") {
        $l++; if ($l > 48) { $l = 0; $c++ } if ($c > 1) { $c = 0; $p++ }
        ($y1,$y2) = (500 + 250*$l + $p*13375, 750 + 250*$l + $p*13375);
        $x1 = 500 + $c*4250;
    }
    elsif ($_[0] eq "HTML") {
        print "</tr>\n<tr>\n";
    }
    elsif ($_[0] eq "PS" || $_[0] eq "PDF") {
        $l++;
        if ($l > 48) { $l = 0; $c++ }
        if ($c > 1) {
            $c = 0;
            $p++;
            print LAT "}\n}\n\\vspace*{\\fill}\n\\clearpage\n".
                "\\vspace*{\\fill}\n".
                "\\makebox[1in]{\n\\raisebox{-.5\\paperheight}[0in][0in]{\n".
                "\\resizebox{!}{\\paperheight}{".
                "\\includegraphics{/tmp/$pid.$p.eps}}\n";
            close EPS;
            open EPS, ">/tmp/$pid.$p.fig";
            print EPS $head;
        }
        ($y1,$y2) = (500 + 250*$l, 750 + 250*$l);
        $x1 = 500 + $c*4250;
    }
}
